
#include <iostream>

#include <ctime>
#include <utility>
#include <map>

#include <boost/static_assert.hpp>
#include <boost/tuple/tuple.hpp>

#include "mkademliastorage.h"

using namespace std;

using namespace boost;
using namespace boost::multi_index;

bool MKademliaStorage::Initialize(STORAGETYPE st)
{
    //  boost::BOOST_STATIC_ASSERT( st != ST_NOTYPE );

    //SetType(st);
    // and to do what?
    ProcessTimeout(0);
    return true;
}

STORAGE_OP_RESULT MKademliaStorage::Put_Special(const std::string& key, const STORE_ITEM& item, time_t timeout)
{
    /*
    size_t count = _st.get<KEY>().count(key);
    DEBUG_LOG("DHT", "there are totally ____________________ " << count << " item for key " << key);
    cerr << "there are totally ____________________ " << count << " item for key " << key<< endl;
    for(; count > 0; --count)
    {
      std::list<STORE_ITEM> items;
      std::list<STORE_ITEM>::iterator itemIter;
      Get(key, items);
      for(itemIter = items.begin(); itemIter != items.end(); ++itemIter)
      {
          DEBUG_LOG("DHT", "ok ->>>>>>> "  << itemIter->first << " <<<<< " << itemIter->second);
          cerr << "ok ->>>>>>> "  << itemIter->first << " <<<<< " << itemIter->second << endl;
      }
    StoreIter iter0, iter1;
    boost::tuples::tie(iter0, iter1) = _st.get<KEY>().equal_range(key);
    while(iter0 != iter1)
    {
        if (iter0->_value == item.first)
        {
            continue;
        }
        bool ok = _st.modify(iter0, Mod(item.first));
        if(!ok)
        {
            ERROR_LOG("DHT", "updating " << key << " ---- " << item.first << "---" << item.second << "FAILED!!!!");
        }
        DEBUG_LOG("DHT", "updating " << key << " ---- " << item.first << "---" << item.second);
        cerr << "updating " << key << " ---- " << item.first << "---" << item.second << endl;
        break;
    }
    }
    */
    return ST_RT_OK;
}


STORAGE_OP_RESULT MKademliaStorage::Put(const std::string& key, const STORE_ITEM& item, time_t timeout)
{

    /*
    if (ST_SINGLE == GetType())
    {
      
    }
    */

    // if (item.second == "-")
    //      return Put_Special(key, item, timeout);

    bool flag = false;
    StoreIter iter0, iter1;
    boost::tuples::tie(iter0, iter1) = _st.get<KEY>().equal_range(key);
    while (iter0 != iter1)
    {
        cout << "DHT" << "adding " << iter0->_version << " ---- " << item.second << endl;

        if (iter0->_version == item.second)
        {
            bool ok = _st.modify(iter0, Mod(item.first, timeout + time(0)));
            if (!ok)
            {
                cout << "DHT" << "updating " << key << " ---- " << item.first << "---" << item.second << "FAILED!!!!" << endl;
                exit(1);
            }

            cout << "DHT" << "updating " << key << " ---- " << item.first << "---" << item.second << endl;
            cerr << "updating " << key << " ---- " << item.first << "---" << item.second << endl;
            flag = true;
        }

        ++iter0;
    }

    if (!flag)
    {
        _st.insert(Store::value_type(key, time(0) + timeout, item.first, item.second));
        cout << "DHT" << "inserting " << key << " ---- " << item.first << "---" << item.second << "---" << (time(0) + timeout) << endl;
        //cerr << "inserting " << key << "---" << item.first << "----" << item.second << endl;
    }
    return ST_RT_OK;
}

STORAGE_OP_RESULT MKademliaStorage::Put(const std::string& key, const std::list<STORE_ITEM>& items, time_t timeout)
{
    std::list<STORE_ITEM>::const_iterator iter;
    for (iter = items.begin(); iter != items.end(); ++iter)
    {
        STORAGE_OP_RESULT rt = Put(key, *iter, timeout);
        if (ST_RT_OK != rt)
            return rt;
    }
    return ST_RT_OK;
}

STORAGE_OP_RESULT MKademliaStorage::Get(const std::string& key, std::list<STORE_ITEM>& items)
{
    items.clear();

    StoreIter iter0, iter1;
    boost::tuples::tie(iter0, iter1) = _st.get<KEY>().equal_range(key);
    while (iter0 != iter1)
    {
        items.push_back(make_pair((*iter0)._value, (*iter0)._version));
        cout << "getting " << iter0->_value << "---" << iter0->_version << "----" << iter0->_timeout << endl;

        ++iter0;
    }

    return ST_RT_OK;
}

STORAGE_OP_RESULT MKademliaStorage::Del(const std::string& key, const std::string& version)
{
    return ST_RT_OK;
}

STORAGE_OP_RESULT MKademliaStorage::Del(const std::string& key, std::list<std::string>& version)
{
    return ST_RT_OK;
}

STORAGE_OP_RESULT MKademliaStorage::Del(time_t t)
{
    StoreTimeIter iter;
    iter = _st.get<TIME>().upper_bound(t);//, MTimeComp());

    if (_st.get<TIME>().begin() != iter)
    {
        //  cerr << "deleting " << iter->_timeout << "-----" << iter->_value << "----" <<iter->_version << "-----" << t << endl;
        _st.get<TIME>().erase(_st.get<TIME>().begin(), iter);
    }

    return ST_RT_OK;
}


void MKademliaStorage::Refresh()
{
    time_t now = time(0);

    cout << "DHT" << "DHT Storage -> Refresh() STARTED. ITEM Count: " << _st.size();

    if (_st.empty())
    {
        return;
    }

    Del(now);

    cout << "DHT" << "DHT Storage -> Refresh() DONE. ITEM Count: " << _st.size();
}

void MKademliaStorage::ProcessTimeout(void* param)
{
    /*MTimer* timer = MTimer::Instance();
    timer->Schedule(KADEMLIA_STORAGE_TIMEOUT, new TrivalCallBackable(MKademliaStorage::ProcessTimeout, "MKademliaStorage--Timeout--Process"));

    MKademliaStorage* st = MKademliaStorage::Instance();*/
    Refresh();
}

void MKademliaStorage::Dump()
{
    StoreTimeIter iter;

    for (iter = _st.get<TIME>().begin(); iter != _st.get<TIME>().end(); iter ++)
    {
        cout << "DHT Storage -> Dumping Storage : " << iter->_key << iter->_timeout << "-----" << iter->_value << "----" << iter->_version << "-----" << endl;
    }
}
